Index: share/man/man9/Makefile
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/share/man/man9/Makefile,v
retrieving revision 1.310.2.2
diff -u -r1.310.2.2 Makefile
--- share/man/man9/Makefile	15 Feb 2008 10:28:46 -0000	1.310.2.2
+++ share/man/man9/Makefile	20 Feb 2008 16:38:07 -0000
@@ -1056,6 +1056,7 @@
 	stack.9 stack_put.9 \
 	stack.9 stack_save.9 \
 	stack.9 stack_sbuf_print.9 \
+	stack.9 stack_sbuf_print_ddb.9 \
 	stack.9 stack_zero.9
 MLINKS+=store.9 subyte.9 \
 	store.9 suswintr.9 \
Index: sys/amd64/amd64/db_trace.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/amd64/amd64/db_trace.c,v
retrieving revision 1.80.2.1
diff -u -r1.80.2.1 db_trace.c
--- sys/amd64/amd64/db_trace.c	21 Nov 2007 16:38:54 -0000	1.80.2.1
+++ sys/amd64/amd64/db_trace.c	17 Jan 2008 17:06:03 -0000
@@ -38,6 +38,7 @@
 #include <machine/md_var.h>
 #include <machine/pcb.h>
 #include <machine/reg.h>
+#include <machine/stack.h>
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -177,18 +178,6 @@
 	return (1);
 }
 
-/*
- * Stack trace.
- */
-#define	INKERNEL(va) (((va) >= DMAP_MIN_ADDRESS && (va) < DMAP_MAX_ADDRESS) \
-	    || ((va) >= KERNBASE && (va) < VM_MAX_KERNEL_ADDRESS))
-
-struct amd64_frame {
-	struct amd64_frame	*f_frame;
-	long			f_retaddr;
-	long			f_arg0;
-};
-
 #define NORMAL		0
 #define	TRAP		1
 #define	INTERRUPT	2
@@ -505,32 +494,6 @@
 		    ctx->pcb_rip, count));
 }
 
-void
-stack_save(struct stack *st)
-{
-	struct amd64_frame *frame;
-	vm_offset_t callpc;
-	register_t rbp;
-
-	stack_zero(st);
-	__asm __volatile("movq %%rbp,%0" : "=r" (rbp));
-	frame = (struct amd64_frame *)rbp;
-	while (1) {
-		if (!INKERNEL((long)frame))
-			break;
-		callpc = frame->f_retaddr;
-		if (!INKERNEL(callpc))
-			break;
-		if (stack_put(st, callpc) == -1)
-			break;
-		if (frame->f_frame <= frame ||
-		    (vm_offset_t)frame->f_frame >=
-		    (vm_offset_t)rbp + KSTACK_PAGES * PAGE_SIZE)
-			break;
-		frame = frame->f_frame;
-	}
-}
-
 int
 amd64_set_watch(watchnum, watchaddr, size, access, d)
 	int watchnum;
Index: sys/amd64/amd64/stack_machdep.c
===================================================================
RCS file: sys/amd64/amd64/stack_machdep.c
diff -N sys/amd64/amd64/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/amd64/amd64/stack_machdep.c	17 Jan 2008 18:33:02 -0000
@@ -0,0 +1,87 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/amd64/amd64/stack_machdep.c,v 1.1 2007/12/02 20:40:30 rwatson Exp $");
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+
+#include <machine/pcb.h>
+#include <machine/stack.h>
+
+#include <vm/vm.h>
+#include <vm/vm_param.h>
+#include <vm/pmap.h>
+
+static void
+stack_capture(struct stack *st, register_t rbp)
+{
+	struct amd64_frame *frame;
+	vm_offset_t callpc;
+
+	stack_zero(st);
+	frame = (struct amd64_frame *)rbp;
+	while (1) {
+		if (!INKERNEL((long)frame))
+			break;
+		callpc = frame->f_retaddr;
+		if (!INKERNEL(callpc))
+			break;
+		if (stack_put(st, callpc) == -1)
+			break;
+		if (frame->f_frame <= frame ||
+		    (vm_offset_t)frame->f_frame >=
+		    (vm_offset_t)rbp + KSTACK_PAGES * PAGE_SIZE)
+			break;
+		frame = frame->f_frame;
+	}
+}
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+	register_t rbp;
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	rbp = td->td_pcb->pcb_rbp;
+	stack_capture(st, rbp);
+}
+
+void
+stack_save(struct stack *st)
+{
+	register_t rbp;
+
+	__asm __volatile("movq %%rbp,%0" : "=r" (rbp));
+	stack_capture(st, rbp);
+}
Index: sys/amd64/include/stack.h
===================================================================
RCS file: sys/amd64/include/stack.h
diff -N sys/amd64/include/stack.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/amd64/include/stack.h	17 Jan 2008 18:33:21 -0000
@@ -0,0 +1,44 @@
+/*-
+ * Mach Operating System
+ * Copyright (c) 1991,1990 Carnegie Mellon University
+ * All Rights Reserved.
+ *
+ * Permission to use, copy, modify and distribute this software and its
+ * documentation is hereby granted, provided that both the copyright
+ * notice and this permission notice appear in all copies of the
+ * software, derivative works or modified versions, and any portions
+ * thereof, and that both notices appear in supporting documentation.
+ *
+ * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS
+ * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
+ * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
+ *
+ * Carnegie Mellon requests users of this software to return to
+ *
+ *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
+ *  School of Computer Science
+ *  Carnegie Mellon University
+ *  Pittsburgh PA 15213-3890
+ *
+ * any improvements or extensions that they make and grant Carnegie the
+ * rights to redistribute these changes.
+ *
+ * $FreeBSD: src/sys/amd64/include/stack.h,v 1.1 2007/12/02 20:40:31 rwatson Exp $
+ */
+
+#ifndef _MACHINE_STACK_H_
+#define	_MACHINE_STACK_H_
+
+/*
+ * Stack trace.
+ */
+#define	INKERNEL(va) (((va) >= DMAP_MIN_ADDRESS && (va) < DMAP_MAX_ADDRESS) \
+	    || ((va) >= KERNBASE && (va) < VM_MAX_KERNEL_ADDRESS))
+
+struct amd64_frame {
+	struct amd64_frame	*f_frame;
+	long			f_retaddr;
+	long			f_arg0;
+};
+
+#endif /* !_MACHINE_STACK_H_ */
Index: sys/arm/arm/db_trace.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/arm/arm/db_trace.c,v
retrieving revision 1.13
diff -u -r1.13 db_trace.c
--- sys/arm/arm/db_trace.c	12 Jul 2006 21:22:42 -0000	1.13
+++ sys/arm/arm/db_trace.c	17 Jan 2008 18:33:59 -0000
@@ -43,14 +43,13 @@
 #include <machine/cpufunc.h>
 #include <machine/db_machdep.h>
 #include <machine/pcb.h>
+#include <machine/stack.h>
 #include <machine/vmparam.h>
 #include <ddb/ddb.h>
 #include <ddb/db_access.h>
 #include <ddb/db_sym.h>
 #include <ddb/db_output.h>
 
-#define INKERNEL(va)	(((vm_offset_t)(va)) >= VM_MIN_KERNEL_ADDRESS)
-
 /*
  * APCS stack frames are awkward beasts, so I don't think even trying to use
  * a structure to represent them is a good idea.
@@ -79,11 +78,6 @@
  * fields are actually present.
  */
 
-#define FR_SCP	(0)
-#define FR_RLV	(-1)
-#define FR_RSP	(-2)
-#define FR_RFP	(-3)
-
 static void
 db_stack_trace_cmd(db_expr_t addr, db_expr_t count)
 {
@@ -215,21 +209,3 @@
 {
 	db_trace_thread(curthread, -1);
 }
-
-void
-stack_save(struct stack *st)
-{
-	vm_offset_t callpc;
-	u_int32_t *frame;
-
-	stack_zero(st);
-	frame = (u_int32_t *)__builtin_frame_address(0);
-	while (1) {
-		if (!INKERNEL(frame))
-			break;
-		callpc = frame[FR_SCP];
-		if (stack_put(st, callpc) == -1)
-			break;
-		frame = (u_int32_t *)(frame[FR_RFP]);
-	}
-}
Index: sys/arm/arm/stack_machdep.c
===================================================================
RCS file: sys/arm/arm/stack_machdep.c
diff -N sys/arm/arm/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/arm/arm/stack_machdep.c	17 Jan 2008 18:34:19 -0000
@@ -0,0 +1,76 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/arm/arm/stack_machdep.c,v 1.1 2007/12/02 20:40:31 rwatson Exp $");
+
+#include <sys/systm.h>
+#include <sys/param.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+
+#include <machine/vmparam.h>
+#include <machine/pcb.h>
+#include <machine/stack.h>
+
+static void
+stack_capture(struct stack *st, u_int32_t *frame)
+{
+	vm_offset_t callpc;
+
+	stack_zero(st);
+	while (1) {
+		if (!INKERNEL(frame))
+			break;
+		callpc = frame[FR_SCP];
+		if (stack_put(st, callpc) == -1)
+			break;
+		frame = (u_int32_t *)(frame[FR_RFP]);
+	}
+}
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+	u_int32_t *frame;
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	frame = (u_int32_t *)td->td_pcb->un_32.pcb32_r11;
+	stack_capture(st, frame);
+}
+
+void
+stack_save(struct stack *st)
+{
+	u_int32_t *frame;
+
+	frame = (u_int32_t *)__builtin_frame_address(0);
+	stack_capture(st, frame);
+}
Index: sys/arm/include/stack.h
===================================================================
RCS file: sys/arm/include/stack.h
diff -N sys/arm/include/stack.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/arm/include/stack.h	17 Jan 2008 18:34:30 -0000
@@ -0,0 +1,42 @@
+/*-
+ * Copyright (c) 2000, 2001 Ben Harris
+ * Copyright (c) 1996 Scott K. Stevens
+ *
+ * Mach Operating System
+ * Copyright (c) 1991,1990 Carnegie Mellon University
+ * All Rights Reserved.
+ * 
+ * Permission to use, copy, modify and distribute this software and its
+ * documentation is hereby granted, provided that both the copyright
+ * notice and this permission notice appear in all copies of the
+ * software, derivative works or modified versions, and any portions
+ * thereof, and that both notices appear in supporting documentation.
+ * 
+ * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
+ * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
+ * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
+ * 
+ * Carnegie Mellon requests users of this software to return to
+ * 
+ *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
+ *  School of Computer Science
+ *  Carnegie Mellon University
+ *  Pittsburgh PA 15213-3890
+ * 
+ * any improvements or extensions that they make and grant Carnegie the
+ * rights to redistribute these changes.
+ *
+ * $FreeBSD: src/sys/arm/include/stack.h,v 1.1 2007/12/02 20:40:31 rwatson Exp $
+ */
+
+#ifndef _MACHINE_STACK_H_
+#define	_MACHINE_STACK_H_
+
+#define INKERNEL(va)	(((vm_offset_t)(va)) >= VM_MIN_KERNEL_ADDRESS)
+
+#define FR_SCP	(0)
+#define FR_RLV	(-1)
+#define FR_RSP	(-2)
+#define FR_RFP	(-3)
+
+#endif /* !_MACHINE_STACK_H_ */
Index: sys/conf/NOTES
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/NOTES,v
retrieving revision 1.1454
diff -u -r1.1454 NOTES
--- sys/conf/NOTES	26 Sep 2007 21:14:17 -0000	1.1454
+++ sys/conf/NOTES	17 Jan 2008 18:34:57 -0000
@@ -471,6 +471,13 @@
 #
 options 	COMPILING_LINT
 
+#
+# STACK enables the stack(9) facility, allowing the capture of kernel stack
+# for the purpose of procinfo(1), etc.  stack(9) will also be compiled in
+# automatically if DDB(4) is compiled into the kernel.
+#
+options 	STACK
+
 
 #####################################################################
 # PERFORMANCE MONITORING OPTIONS
Index: sys/conf/files
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files,v
retrieving revision 1.1243.2.4
diff -u -r1.1243.2.4 files
--- sys/conf/files	14 Feb 2008 18:33:49 -0000	1.1243.2.4
+++ sys/conf/files	20 Feb 2008 16:38:36 -0000
@@ -1503,7 +1503,7 @@
 kern/subr_scanf.c		standard
 kern/subr_sleepqueue.c		standard
 kern/subr_smp.c			standard
-kern/subr_stack.c		optional ddb
+kern/subr_stack.c		optional ddb | stack
 kern/subr_taskqueue.c		standard
 kern/subr_trap.c		standard
 kern/subr_turnstile.c		standard
Index: sys/conf/files.amd64
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.amd64,v
retrieving revision 1.107.2.5
diff -u -r1.107.2.5 files.amd64
--- sys/conf/files.amd64	3 Feb 2008 07:28:38 -0000	1.107.2.5
+++ sys/conf/files.amd64	20 Feb 2008 16:38:36 -0000
@@ -121,6 +121,7 @@
 amd64/amd64/pmap.c		standard
 amd64/amd64/prof_machdep.c	optional	profiling-routine
 amd64/amd64/sigtramp.S		standard
+amd64/amd64/stack_machdep.c	optional	ddb | stack
 amd64/amd64/support.S		standard
 amd64/amd64/sys_machdep.c	standard
 amd64/amd64/trap.c		standard
Index: sys/conf/files.arm
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.arm,v
retrieving revision 1.15
diff -u -r1.15 files.arm
--- sys/conf/files.arm	3 Jul 2007 12:13:42 -0000	1.15
+++ sys/conf/files.arm	17 Jan 2008 18:35:49 -0000
@@ -38,6 +38,7 @@
 arm/arm/pmap.c			standard
 arm/arm/setcpsr.S		standard
 arm/arm/setstack.s		standard
+arm/arm/stack_machdep.c		optional	ddb | stack
 arm/arm/support.S		standard
 arm/arm/swtch.S			standard
 arm/arm/sys_machdep.c		standard
Index: sys/conf/files.i386
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.i386,v
retrieving revision 1.580.2.5
diff -u -r1.580.2.5 files.i386
--- sys/conf/files.i386	3 Feb 2008 07:28:38 -0000	1.580.2.5
+++ sys/conf/files.i386	20 Feb 2008 16:38:36 -0000
@@ -298,6 +298,7 @@
 i386/i386/perfmon.c		optional perfmon
 i386/i386/pmap.c		standard
 i386/i386/ptrace_machdep.c	standard
+i386/i386/stack_machdep.c	optional ddb | stack
 i386/i386/support.s		standard
 i386/i386/swtch.s		standard
 i386/i386/sys_machdep.c		standard
Index: sys/conf/files.ia64
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.ia64,v
retrieving revision 1.92
diff -u -r1.92 files.ia64
--- sys/conf/files.ia64	3 Jul 2007 12:13:42 -0000	1.92
+++ sys/conf/files.ia64	17 Jan 2008 18:58:06 -0000
@@ -98,6 +98,7 @@
 ia64/ia64/setjmp.S		standard
 ia64/ia64/ssc.c			optional	ski
 ia64/ia64/sscdisk.c		optional	ski
+ia64/ia64/stack_machdep.c	optional	ddb | stack
 ia64/ia64/support.S		standard
 ia64/ia64/sys_machdep.c		standard
 ia64/ia64/syscall.S		standard
Index: sys/conf/files.pc98
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.pc98,v
retrieving revision 1.356
diff -u -r1.356 files.pc98
--- sys/conf/files.pc98	3 Jul 2007 12:13:42 -0000	1.356
+++ sys/conf/files.pc98	17 Jan 2008 19:31:23 -0000
@@ -177,6 +177,7 @@
 i386/i386/perfmon.c		optional perfmon
 i386/i386/pmap.c		standard
 i386/i386/ptrace_machdep.c	standard
+i386/i386/stack_machdep.c	optional ddb | stack
 i386/i386/support.s		standard
 i386/i386/swtch.s		standard
 i386/i386/sys_machdep.c		standard
Index: sys/conf/files.powerpc
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.powerpc,v
retrieving revision 1.65
diff -u -r1.65 files.powerpc
--- sys/conf/files.powerpc	3 Jul 2007 12:13:42 -0000	1.65
+++ sys/conf/files.powerpc	17 Jan 2008 18:58:21 -0000
@@ -61,6 +61,7 @@
 powerpc/powerpc/sc_machdep.c	optional	sc
 powerpc/powerpc/setjmp.S	standard
 powerpc/powerpc/sigcode.S	standard
+powerpc/powerpc/stack_machdep.c	optional	ddb | stack
 powerpc/powerpc/suswintr.c	standard
 powerpc/powerpc/syncicache.c	standard
 powerpc/powerpc/sys_machdep.c	standard
Index: sys/conf/files.sparc64
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.sparc64,v
retrieving revision 1.92
diff -u -r1.92 files.sparc64
--- sys/conf/files.sparc64	3 Jul 2007 12:13:42 -0000	1.92
+++ sys/conf/files.sparc64	17 Jan 2008 18:58:30 -0000
@@ -124,6 +124,7 @@
 sparc64/sparc64/rwindow.c	standard
 sparc64/sparc64/sc_machdep.c	optional	sc
 sparc64/sparc64/spitfire.c	standard
+sparc64/sparc64/stack_machdep.c	optional	ddb | stack
 sparc64/sparc64/support.S	standard
 sparc64/sparc64/sys_machdep.c	standard
 sparc64/sparc64/swtch.S		standard
Index: sys/conf/files.sun4v
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/files.sun4v,v
retrieving revision 1.11
diff -u -r1.11 files.sun4v
--- sys/conf/files.sun4v	3 Jul 2007 12:13:42 -0000	1.11
+++ sys/conf/files.sun4v	17 Jan 2008 19:00:35 -0000
@@ -74,6 +74,7 @@
 sparc64/sparc64/rwindow.c		standard
 sun4v/sun4v/rtc.c		standard
 sun4v/sun4v/simdisk.c		optional	simulator
+sun4v/sun4v/stack_machdep.c	optional	ddb | stack
 sun4v/sun4v/support.S		standard
 sparc64/sparc64/sys_machdep.c	standard
 sun4v/sun4v/swtch.S		standard
Index: sys/conf/options
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/conf/options,v
retrieving revision 1.608
diff -u -r1.608 options
--- sys/conf/options	23 Sep 2007 07:34:23 -0000	1.608
+++ sys/conf/options	17 Jan 2008 19:00:48 -0000
@@ -141,6 +141,7 @@
 SLEEPQUEUE_PROFILING
 SLHCI_DEBUG	opt_slhci.h
 SPX_HACK
+STACK		opt_stack.h
 SUIDDIR
 MSGMNB		opt_sysvipc.h
 MSGMNI		opt_sysvipc.h
Index: sys/i386/conf/GENERIC
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/i386/conf/GENERIC,v
retrieving revision 1.474.2.3
diff -u -r1.474.2.3 GENERIC
--- sys/i386/conf/GENERIC	3 Feb 2008 07:28:37 -0000	1.474.2.3
+++ sys/i386/conf/GENERIC	20 Feb 2008 16:39:33 -0000
@@ -54,6 +54,7 @@
 options 	COMPAT_FREEBSD6		# Compatible with FreeBSD6
 options 	SCSI_DELAY=5000		# Delay (in ms) before probing SCSI
 options 	KTRACE			# ktrace(1) support
+options 	STACK			# stack(9) support
 options 	SYSVSHM			# SYSV-style shared memory
 options 	SYSVMSG			# SYSV-style message queues
 options 	SYSVSEM			# SYSV-style semaphores
Index: sys/i386/i386/db_trace.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/i386/i386/db_trace.c,v
retrieving revision 1.79
diff -u -r1.79 db_trace.c
--- sys/i386/i386/db_trace.c	19 Feb 2007 10:57:47 -0000	1.79
+++ sys/i386/i386/db_trace.c	17 Jan 2008 19:02:34 -0000
@@ -31,13 +31,13 @@
 #include <sys/systm.h>
 #include <sys/kdb.h>
 #include <sys/proc.h>
-#include <sys/stack.h>
 #include <sys/sysent.h>
 
 #include <machine/cpu.h>
 #include <machine/md_var.h>
 #include <machine/pcb.h>
 #include <machine/reg.h>
+#include <machine/stack.h>
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -166,18 +166,6 @@
 	return (1);
 }
 
-/*
- * Stack trace.
- */
-#define	INKERNEL(va)	(((vm_offset_t)(va)) >= USRSTACK && \
-	    ((vm_offset_t)(va)) < VM_MAX_KERNEL_ADDRESS)
-
-struct i386_frame {
-	struct i386_frame	*f_frame;
-	int			f_retaddr;
-	int			f_arg0;
-};
-
 #define NORMAL		0
 #define	TRAP		1
 #define	INTERRUPT	2
@@ -537,32 +525,6 @@
 		    ctx->pcb_eip, count));
 }
 
-void
-stack_save(struct stack *st)
-{
-	struct i386_frame *frame;
-	vm_offset_t callpc;
-	register_t ebp;
-
-	stack_zero(st);
-	__asm __volatile("movl %%ebp,%0" : "=r" (ebp));
-	frame = (struct i386_frame *)ebp;
-	while (1) {
-		if (!INKERNEL(frame))
-			break;
-		callpc = frame->f_retaddr;
-		if (!INKERNEL(callpc))
-			break;
-		if (stack_put(st, callpc) == -1)
-			break;
-		if (frame->f_frame <= frame ||
-		    (vm_offset_t)frame->f_frame >=
-		    (vm_offset_t)ebp + KSTACK_PAGES * PAGE_SIZE)
-			break;
-		frame = frame->f_frame;
-	}
-}
-
 int
 i386_set_watch(watchnum, watchaddr, size, access, d)
 	int watchnum;
Index: sys/i386/i386/stack_machdep.c
===================================================================
RCS file: sys/i386/i386/stack_machdep.c
diff -N sys/i386/i386/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/i386/i386/stack_machdep.c	17 Jan 2008 19:28:20 -0000
@@ -0,0 +1,87 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/i386/i386/stack_machdep.c,v 1.2 2007/12/02 21:07:49 rwatson Exp $");
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+
+#include <machine/pcb.h>
+#include <machine/stack.h>
+
+#include <vm/vm.h>
+#include <vm/vm_param.h>
+#include <vm/pmap.h>
+
+static void
+stack_capture(struct stack *st, register_t ebp)
+{
+	struct i386_frame *frame;
+	vm_offset_t callpc;
+
+	stack_zero(st);
+	frame = (struct i386_frame *)ebp;
+	while (1) {
+		if (!INKERNEL(frame))
+			break;
+		callpc = frame->f_retaddr;
+		if (!INKERNEL(callpc))
+			break;
+		if (stack_put(st, callpc) == -1)
+			break;
+		if (frame->f_frame <= frame ||
+		    (vm_offset_t)frame->f_frame >=
+		    (vm_offset_t)ebp + KSTACK_PAGES * PAGE_SIZE)
+			break;
+		frame = frame->f_frame;
+	}
+}
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+	register_t ebp;
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	ebp = td->td_pcb->pcb_ebp;
+	stack_capture(st, ebp);
+}
+
+void
+stack_save(struct stack *st)
+{
+	register_t ebp;
+
+	__asm __volatile("movl %%ebp,%0" : "=r" (ebp));
+	stack_capture(st, ebp);
+}
Index: sys/i386/include/stack.h
===================================================================
RCS file: sys/i386/include/stack.h
diff -N sys/i386/include/stack.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/i386/include/stack.h	17 Jan 2008 19:03:12 -0000
@@ -0,0 +1,44 @@
+/*-
+ * Mach Operating System
+ * Copyright (c) 1991,1990 Carnegie Mellon University
+ * All Rights Reserved.
+ *
+ * Permission to use, copy, modify and distribute this software and its
+ * documentation is hereby granted, provided that both the copyright
+ * notice and this permission notice appear in all copies of the
+ * software, derivative works or modified versions, and any portions
+ * thereof, and that both notices appear in supporting documentation.
+ *
+ * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS
+ * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
+ * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
+ *
+ * Carnegie Mellon requests users of this software to return to
+ *
+ *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
+ *  School of Computer Science
+ *  Carnegie Mellon University
+ *  Pittsburgh PA 15213-3890
+ *
+ * any improvements or extensions that they make and grant Carnegie the
+ * rights to redistribute these changes.
+ *
+ * $FreeBSD: src/sys/i386/include/stack.h,v 1.1 2007/12/02 20:40:32 rwatson Exp $
+ */
+
+#ifndef _MACHINE_STACK_H_
+#define	_MACHINE_STACK_H_
+
+/*
+ * Stack trace.
+ */
+#define INKERNEL(va)	(((vm_offset_t)(va)) >= USRSTACK && \
+	    ((vm_offset_t)(va)) < VM_MAX_KERNEL_ADDRESS)
+
+struct i386_frame {
+	struct i386_frame	*f_frame;
+	int			 f_retaddr;
+	int			 f_arg0;
+};
+
+#endif /* !_MACHINE_STACK_H_ */
Index: sys/ia64/conf/GENERIC
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/ia64/conf/GENERIC,v
retrieving revision 1.92
diff -u -r1.92 GENERIC
--- sys/ia64/conf/GENERIC	26 Sep 2007 20:05:07 -0000	1.92
+++ sys/ia64/conf/GENERIC	17 Jan 2008 19:03:33 -0000
@@ -50,6 +50,7 @@
 options 	SMP		# Symmetric Multi-Processor support
 options 	SOFTUPDATES	# Enable FFS soft updates support
 options 	UFS_GJOURNAL	# Enable gjournal-based UFS journaling
+options 	STACK		# stack(9) support
 options 	SYSVMSG		# SYSV-style message queues
 options 	SYSVSEM		# SYSV-style semaphores
 options 	SYSVSHM		# SYSV-style shared memory
Index: sys/ia64/ia64/db_machdep.c
===================================================================
RCS file: /home/data/fbsd-cvs/ncvs/src/sys/ia64/ia64/db_machdep.c,v
retrieving revision 1.4
diff -u -r1.4 db_machdep.c
--- sys/ia64/ia64/db_machdep.c	30 Jul 2007 22:42:33 -0000	1.4
+++ sys/ia64/ia64/db_machdep.c	17 Jan 2008 19:07:39 -0000
@@ -595,18 +595,6 @@
 	return (db_backtrace(td, ctx, count));
 }
 
-void
-stack_save(struct stack *st)
-{
-
-	stack_zero(st);
-	/*
-	 * Nothing for now.
-	 * Is libuwx reentrant?
-	 * Can unw_create* sleep?
-	 */
-}
-
 #ifdef EXCEPTION_TRACING
 
 extern long xtrace[];
Index: sys/ia64/ia64/stack_machdep.c
===================================================================
RCS file: sys/ia64/ia64/stack_machdep.c
diff -N sys/ia64/ia64/stack_machdep.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/ia64/ia64/stack_machdep.c	17 Jan 2008 19:07:53 -0000
@@ -0,0 +1,57 @@
+/*-
+ * Copyright (c) 2005 Antoine Brodin
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/sys/ia64/ia64/stack_machdep.c,v 1.1 2007/12/02 20:40:33 rwatson Exp $");
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/proc.h>
+#include <sys/stack.h>
+
+void
+stack_save_td(struct stack *st, struct thread *td)
+{
+
+	if (TD_IS_SWAPPED(td))
+		panic("stack_save_td: swapped");
+	if (TD_IS_RUNNING(td))
+		panic("stack_save_td: running");
+
+	stack_zero(st);
+}
+
+void
+stack_save(struct stack *st)
+{
+
+	stack_zero(st);
+	/*
+	 * Nothing for now.
+	 * Is libuwx reentrant?
+	 * Can unw_create* sleep?
+	 */
+}
